Blocks

Operations for retrieving block and microblock data.

Get Nakamoto block by ID

get
/v3/blocks/{block_id}

Get a specific Nakamoto block (Stacks 3.x+) by its index block hash. This endpoint streams the block data from the Nakamoto staging blocks database where Nakamoto blocks are stored with additional metadata including tenure information.

Compatibility: Works with Nakamoto blocks only. For Stacks 2.x blocks, use /v2/blocks/{block_id}.

Path parameters
block_idstring · min: 64 · max: 64Required

The block's ID hash (64-character hex string)

Example: 0123456789abcdef0123456789abcdef0123456789abcdef0123456789abcdefPattern: ^[0-9a-f]{64}$
Responses
chevron-right
200

The raw SIP-003-encoded block will be returned.

application/octet-stream
string · binaryOptional
get
/v3/blocks/{block_id}

Fetch a Nakamoto block by its height and optional tip

get
/v3/blocks/height/{block_height}

Fetch a Nakamoto block by its height and optional tip.

Path parameters
block_heightinteger · max: 4294967295Required

The block's height (max 4294967295)

Query parameters
tipstring · max: 64Optional

Stacks chain tip to query from. Options:

  • (empty/omitted): Use latest anchored tip (canonical confirmed state)
  • latest: Use latest known tip including unconfirmed microblocks
  • {block_id}: Use specific block ID (64 hex characters)
Example: latestPattern: ^(latest|[0-9a-f]{64})?$
Responses
chevron-right
200

The raw SIP-003-encoded block will be returned.

application/octet-stream
string · binaryOptional
get
/v3/blocks/height/{block_height}

Fetch metadata about the ongoing Nakamoto tenure

get
/v3/tenures/info

Fetch metadata about the ongoing Nakamoto tenure. This information is sufficient to obtain and authenticate the highest complete tenure, as well as obtain new tenure blocks.

Responses
chevron-right
200

Metadata about the ongoing tenure

application/json
consensus_hashstringOptional

Consensus hash of the tenure

Pattern: ^[0-9a-f]{40}$
tenure_start_block_idstringOptional

Block ID where the tenure started

Pattern: ^[0-9a-f]{64}$
parent_consensus_hashstringOptional

Parent consensus hash

Pattern: ^[0-9a-f]{40}$
parent_tenure_start_block_idstringOptional

Parent tenure start block ID

Pattern: ^[0-9a-f]{64}$
tip_block_idstringOptional

Current tip block ID

Pattern: ^[0-9a-f]{64}$
tip_heightintegerOptional

Current tip height

reward_cycleintegerOptional

Current reward cycle

get
/v3/tenures/info
200

Metadata about the ongoing tenure

Fetch a sequence of Nakamoto blocks in a tenure

get
/v3/tenures/{block_id}

Fetch a sequence of Nakamoto blocks in a tenure. The blocks will be served in order from highest to lowest. The blocks will be encoded in their SIP-003 wire format, and concatenated together.

Path parameters
block_idstring · min: 64 · max: 64Required

The tenure-start block ID of the tenure to query (64-character hex string)

Example: 0123456789abcdef0123456789abcdef0123456789abcdef0123456789abcdefPattern: ^[0-9a-f]{64}$
Query parameters
stopstring · min: 64 · max: 64Optional

The block ID hash of the highest block in this tenure that is already known to the caller. Neither the corresponding block nor any of its ancestors will be served. This is used to fetch tenure blocks that the caller does not have.

Pattern: ^[0-9a-f]{64}$
Responses
chevron-right
200

SIP-003-encoded Nakamoto blocks, concatenated together

application/octet-stream
string · binaryOptional
get
/v3/tenures/{block_id}

Get the list of Stacks blocks in a tenure

get
/v3/tenures/blocks/{consensus_hash}

Get the list of blocks in a tenure. The blocks will be shown in order from highest to lowest.

Path parameters
consensus_hashstringRequired

The hex-encoded consensus hash of the tenure to query (40 hexadecimal characters, without 0x prefix)

Pattern: ^[0-9a-f]{40}$
Responses
chevron-right
200

List of Stacks blocks in the tenure

application/json
consensus_hashstringOptional

Consensus hash of the tenure

Pattern: ^[0-9a-f]{40}$
burn_block_heightinteger · uint64Optional

Height of the Bitcoin block

burn_block_hashstringOptional

Hash of the Bitcoin block

Pattern: ^[0-9a-f]{64}$
get
/v3/tenures/blocks/{consensus_hash}

Get the list of Nakamoto Stacks blocks in a tenure given Bitcoin block hash

get
/v3/tenures/blocks/hash/{burnchain_block_hash}

Get the list of Nakamoto blocks in a tenure given the Bitcoin block hash. The blocks will be shown in order from highest to lowest. This is only for Nakamoto blocks, Epoch2 ones will not be shown.

Path parameters
burnchain_block_hashstringRequired

The hex-encoded Bitcoin block hash of the tenure to query (64 hexadecimal characters, without 0x prefix)

Pattern: ^[0-9a-f]{64}$
Responses
chevron-right
200

List of Stacks blocks in the tenure

application/json
consensus_hashstringOptional

Consensus hash of the tenure

Pattern: ^[0-9a-f]{40}$
burn_block_heightinteger · uint64Optional

Height of the Bitcoin block

burn_block_hashstringOptional

Hash of the Bitcoin block

Pattern: ^[0-9a-f]{64}$
get
/v3/tenures/blocks/hash/{burnchain_block_hash}

Get the list of Nakamoto Stacks blocks in a tenure given Bitcoin block height

get
/v3/tenures/blocks/height/{burnchain_block_height}

Get the list of Nakamoto blocks in a tenure given the Bitcoin block height. The blocks will be shown in order from highest to lowest. This is only for Nakamoto blocks, Epoch2 ones will not be shown.

Path parameters
burnchain_block_heightinteger · max: 4294967295Required

The Bitcoin block height of the tenure to query

Responses
chevron-right
200

List of Stacks blocks in the tenure

application/json
consensus_hashstringOptional

Consensus hash of the tenure

Pattern: ^[0-9a-f]{40}$
burn_block_heightinteger · uint64Optional

Height of the Bitcoin block

burn_block_hashstringOptional

Hash of the Bitcoin block

Pattern: ^[0-9a-f]{64}$
get
/v3/tenures/blocks/height/{burnchain_block_height}

Get latest sortition information

get
/v3/sortitions

Get sortition information about the latest burnchain block processed by this node. Returns a single-element array with the latest sortition.

Responses
chevron-right
200

Latest sortition information

application/json

Array of sortition information objects from the burnchain

burn_block_hashstringRequired

The burnchain header hash of the block that triggered this event

Pattern: ^0x[0-9a-f]{64}$
burn_block_heightintegerRequired

The burn height of the block that triggered this event

burn_header_timestampintegerRequired

The burn block time of the sortition (Unix timestamp)

sortition_idstringRequired

This sortition ID of the block that triggered this event. This incorporates PoX forking information and the burn block hash to obtain an identifier that is unique across PoX forks and burnchain forks.

Pattern: ^0x[0-9a-f]{64}$
parent_sortition_idstringRequired

The parent of this burn block's Sortition ID

Pattern: ^0x[0-9a-f]{64}$
consensus_hashstringRequired

The consensus hash of the block that triggered this event. This incorporates PoX forking information and burn op information to obtain an identifier that is unique across PoX forks and burnchain forks.

Pattern: ^0x[0-9a-f]{40}$
was_sortitionbooleanRequired

Boolean indicating whether or not there was a successful sortition (i.e. a winning block or miner was chosen). This will also be true if this sortition corresponds to a shadow block.

miner_pk_hash160string · nullableOptional

If sortition occurred, and the miner's VRF key registration associated a nakamoto mining pubkey with their commit, this will contain the Hash160 of that mining key.

Pattern: ^0x[0-9a-f]{40}$
stacks_parent_chstring · nullableOptional

If sortition occurred, this will be the consensus hash of the burn block corresponding to the winning block commit's parent block ptr. In 3.x, this is the consensus hash of the tenure that this new burn block's miner will be building off of.

Pattern: ^0x[0-9a-f]{40}$
last_sortition_chstring · nullableOptional

If sortition occurred, this will be the consensus hash of the most recent sortition before this one.

Pattern: ^0x[0-9a-f]{40}$
committed_block_hashstring · nullableOptional

In Stacks 2.x, this is the winning block. In Stacks 3.x, this is the first block of the parent tenure.

Pattern: ^0x[0-9a-f]{64}$
vrf_seedstring · nullableOptional

This is the VRF seed generated by this sortition

Pattern: ^0x[0-9a-f]{64}$
get
/v3/sortitions

Get latest and last winning sortitions

get
/v3/sortitions/latest_and_last

Get sortition information about the latest burn block with a winning miner AND the previous such burn block. Returns an array with two sortition objects.

Responses
chevron-right
200

Latest and last sortition information

application/json

Array of sortition information objects from the burnchain

burn_block_hashstringRequired

The burnchain header hash of the block that triggered this event

Pattern: ^0x[0-9a-f]{64}$
burn_block_heightintegerRequired

The burn height of the block that triggered this event

burn_header_timestampintegerRequired

The burn block time of the sortition (Unix timestamp)

sortition_idstringRequired

This sortition ID of the block that triggered this event. This incorporates PoX forking information and the burn block hash to obtain an identifier that is unique across PoX forks and burnchain forks.

Pattern: ^0x[0-9a-f]{64}$
parent_sortition_idstringRequired

The parent of this burn block's Sortition ID

Pattern: ^0x[0-9a-f]{64}$
consensus_hashstringRequired

The consensus hash of the block that triggered this event. This incorporates PoX forking information and burn op information to obtain an identifier that is unique across PoX forks and burnchain forks.

Pattern: ^0x[0-9a-f]{40}$
was_sortitionbooleanRequired

Boolean indicating whether or not there was a successful sortition (i.e. a winning block or miner was chosen). This will also be true if this sortition corresponds to a shadow block.

miner_pk_hash160string · nullableOptional

If sortition occurred, and the miner's VRF key registration associated a nakamoto mining pubkey with their commit, this will contain the Hash160 of that mining key.

Pattern: ^0x[0-9a-f]{40}$
stacks_parent_chstring · nullableOptional

If sortition occurred, this will be the consensus hash of the burn block corresponding to the winning block commit's parent block ptr. In 3.x, this is the consensus hash of the tenure that this new burn block's miner will be building off of.

Pattern: ^0x[0-9a-f]{40}$
last_sortition_chstring · nullableOptional

If sortition occurred, this will be the consensus hash of the most recent sortition before this one.

Pattern: ^0x[0-9a-f]{40}$
committed_block_hashstring · nullableOptional

In Stacks 2.x, this is the winning block. In Stacks 3.x, this is the first block of the parent tenure.

Pattern: ^0x[0-9a-f]{64}$
vrf_seedstring · nullableOptional

This is the VRF seed generated by this sortition

Pattern: ^0x[0-9a-f]{64}$
get
/v3/sortitions/latest_and_last

Get sortition by consensus hash

get
/v3/sortitions/consensus/{consensus_hash}

Get sortition information for a specific consensus hash. Returns a single-element array with the matching sortition.

Path parameters
consensus_hashstringRequired

Hex-encoded consensus hash (40 characters)

Pattern: ^[0-9a-f]{40}$
Responses
chevron-right
200

Sortition information for the consensus hash

application/json

Array of sortition information objects from the burnchain

burn_block_hashstringRequired

The burnchain header hash of the block that triggered this event

Pattern: ^0x[0-9a-f]{64}$
burn_block_heightintegerRequired

The burn height of the block that triggered this event

burn_header_timestampintegerRequired

The burn block time of the sortition (Unix timestamp)

sortition_idstringRequired

This sortition ID of the block that triggered this event. This incorporates PoX forking information and the burn block hash to obtain an identifier that is unique across PoX forks and burnchain forks.

Pattern: ^0x[0-9a-f]{64}$
parent_sortition_idstringRequired

The parent of this burn block's Sortition ID

Pattern: ^0x[0-9a-f]{64}$
consensus_hashstringRequired

The consensus hash of the block that triggered this event. This incorporates PoX forking information and burn op information to obtain an identifier that is unique across PoX forks and burnchain forks.

Pattern: ^0x[0-9a-f]{40}$
was_sortitionbooleanRequired

Boolean indicating whether or not there was a successful sortition (i.e. a winning block or miner was chosen). This will also be true if this sortition corresponds to a shadow block.

miner_pk_hash160string · nullableOptional

If sortition occurred, and the miner's VRF key registration associated a nakamoto mining pubkey with their commit, this will contain the Hash160 of that mining key.

Pattern: ^0x[0-9a-f]{40}$
stacks_parent_chstring · nullableOptional

If sortition occurred, this will be the consensus hash of the burn block corresponding to the winning block commit's parent block ptr. In 3.x, this is the consensus hash of the tenure that this new burn block's miner will be building off of.

Pattern: ^0x[0-9a-f]{40}$
last_sortition_chstring · nullableOptional

If sortition occurred, this will be the consensus hash of the most recent sortition before this one.

Pattern: ^0x[0-9a-f]{40}$
committed_block_hashstring · nullableOptional

In Stacks 2.x, this is the winning block. In Stacks 3.x, this is the first block of the parent tenure.

Pattern: ^0x[0-9a-f]{64}$
vrf_seedstring · nullableOptional

This is the VRF seed generated by this sortition

Pattern: ^0x[0-9a-f]{64}$
get
/v3/sortitions/consensus/{consensus_hash}

Get sortition by burn header hash

get
/v3/sortitions/burn/{burn_header_hash}

Get sortition information for a specific burn header hash. Returns a single-element array with the matching sortition.

Path parameters
burn_header_hashstringRequired

Hex-encoded burn header hash (64 characters)

Pattern: ^[0-9a-f]{64}$
Responses
chevron-right
200

Sortition information for the burn header hash

application/json

Array of sortition information objects from the burnchain

burn_block_hashstringRequired

The burnchain header hash of the block that triggered this event

Pattern: ^0x[0-9a-f]{64}$
burn_block_heightintegerRequired

The burn height of the block that triggered this event

burn_header_timestampintegerRequired

The burn block time of the sortition (Unix timestamp)

sortition_idstringRequired

This sortition ID of the block that triggered this event. This incorporates PoX forking information and the burn block hash to obtain an identifier that is unique across PoX forks and burnchain forks.

Pattern: ^0x[0-9a-f]{64}$
parent_sortition_idstringRequired

The parent of this burn block's Sortition ID

Pattern: ^0x[0-9a-f]{64}$
consensus_hashstringRequired

The consensus hash of the block that triggered this event. This incorporates PoX forking information and burn op information to obtain an identifier that is unique across PoX forks and burnchain forks.

Pattern: ^0x[0-9a-f]{40}$
was_sortitionbooleanRequired

Boolean indicating whether or not there was a successful sortition (i.e. a winning block or miner was chosen). This will also be true if this sortition corresponds to a shadow block.

miner_pk_hash160string · nullableOptional

If sortition occurred, and the miner's VRF key registration associated a nakamoto mining pubkey with their commit, this will contain the Hash160 of that mining key.

Pattern: ^0x[0-9a-f]{40}$
stacks_parent_chstring · nullableOptional

If sortition occurred, this will be the consensus hash of the burn block corresponding to the winning block commit's parent block ptr. In 3.x, this is the consensus hash of the tenure that this new burn block's miner will be building off of.

Pattern: ^0x[0-9a-f]{40}$
last_sortition_chstring · nullableOptional

If sortition occurred, this will be the consensus hash of the most recent sortition before this one.

Pattern: ^0x[0-9a-f]{40}$
committed_block_hashstring · nullableOptional

In Stacks 2.x, this is the winning block. In Stacks 3.x, this is the first block of the parent tenure.

Pattern: ^0x[0-9a-f]{64}$
vrf_seedstring · nullableOptional

This is the VRF seed generated by this sortition

Pattern: ^0x[0-9a-f]{64}$
get
/v3/sortitions/burn/{burn_header_hash}

Get sortition by burn block height

get
/v3/sortitions/burn_height/{height}

Get sortition information for a specific burn block height. Returns a single-element array with the matching sortition.

Path parameters
heightinteger · max: 4294967295Required

Burn block height (integer, max 4294967295)

Responses
chevron-right
200

Sortition information for the burn block height

application/json

Array of sortition information objects from the burnchain

burn_block_hashstringRequired

The burnchain header hash of the block that triggered this event

Pattern: ^0x[0-9a-f]{64}$
burn_block_heightintegerRequired

The burn height of the block that triggered this event

burn_header_timestampintegerRequired

The burn block time of the sortition (Unix timestamp)

sortition_idstringRequired

This sortition ID of the block that triggered this event. This incorporates PoX forking information and the burn block hash to obtain an identifier that is unique across PoX forks and burnchain forks.

Pattern: ^0x[0-9a-f]{64}$
parent_sortition_idstringRequired

The parent of this burn block's Sortition ID

Pattern: ^0x[0-9a-f]{64}$
consensus_hashstringRequired

The consensus hash of the block that triggered this event. This incorporates PoX forking information and burn op information to obtain an identifier that is unique across PoX forks and burnchain forks.

Pattern: ^0x[0-9a-f]{40}$
was_sortitionbooleanRequired

Boolean indicating whether or not there was a successful sortition (i.e. a winning block or miner was chosen). This will also be true if this sortition corresponds to a shadow block.

miner_pk_hash160string · nullableOptional

If sortition occurred, and the miner's VRF key registration associated a nakamoto mining pubkey with their commit, this will contain the Hash160 of that mining key.

Pattern: ^0x[0-9a-f]{40}$
stacks_parent_chstring · nullableOptional

If sortition occurred, this will be the consensus hash of the burn block corresponding to the winning block commit's parent block ptr. In 3.x, this is the consensus hash of the tenure that this new burn block's miner will be building off of.

Pattern: ^0x[0-9a-f]{40}$
last_sortition_chstring · nullableOptional

If sortition occurred, this will be the consensus hash of the most recent sortition before this one.

Pattern: ^0x[0-9a-f]{40}$
committed_block_hashstring · nullableOptional

In Stacks 2.x, this is the winning block. In Stacks 3.x, this is the first block of the parent tenure.

Pattern: ^0x[0-9a-f]{64}$
vrf_seedstring · nullableOptional

This is the VRF seed generated by this sortition

Pattern: ^0x[0-9a-f]{64}$
get
/v3/sortitions/burn_height/{height}

Get number of blocks signed by signer during a given reward cycle

get
/v3/signer/{signer_pubkey}/{cycle_number}

Get number of blocks signed by signer during a given reward cycle

Path parameters
signer_pubkeystringRequired

Hex-encoded compressed Secp256k1 public key of signer

Pattern: ^0[23][0-9a-f]{64}$
cycle_numberintegerRequired

Reward cycle number

Query parameters
tipstring · max: 64Optional

Stacks chain tip to query from. Options:

  • (empty/omitted): Use latest anchored tip (canonical confirmed state)
  • latest: Use latest known tip including unconfirmed microblocks
  • {block_id}: Use specific block ID (64 hex characters)
Example: latestPattern: ^(latest|[0-9a-f]{64})?$
Responses
chevron-right
200

Number of blocks signed

application/json
blocks_signedintegerRequired

Number of blocks signed by this signer

get
/v3/signer/{signer_pubkey}/{cycle_number}

Get stream of confirmed microblocks (Epoch 2.x)

get
/v2/microblocks/confirmed/{block_id}

Get microblocks that were confirmed by the given anchored block. The microblocks are returned as a binary stream of concatenated microblock data.

Path parameters
block_idstringRequired

Hex-encoded Stacks block ID (64 characters)

Pattern: ^[0-9a-f]{64}$
Query parameters
tipstring · max: 64Optional

Stacks chain tip to query from. Options:

  • (empty/omitted): Use latest anchored tip (canonical confirmed state)
  • latest: Use latest known tip including unconfirmed microblocks
  • {block_id}: Use specific block ID (64 hex characters)
Example: latestPattern: ^(latest|[0-9a-f]{64})?$
Responses
chevron-right
200

Stream of confirmed microblocks

application/octet-stream
string · binaryOptional
get
/v2/microblocks/confirmed/{block_id}

Get a stream of microblocks beginning with the given microblock (Epoch 2.x).

get
/v2/microblocks/{microblock_id}
Path parameters
microblock_idstringRequired

Hex-encoded microblock hash (64 characters)

Pattern: ^[0-9a-f]{64}$
Responses
chevron-right
200

The microblock data

application/octet-stream
string · binaryOptional
get
/v2/microblocks/{microblock_id}

Get stream of unconfirmed microblocks (Epoch 2.x)

get
/v2/microblocks/unconfirmed/{block_id}/{seq}

Get unconfirmed microblocks starting from a specific sequence number. The microblocks are returned as a binary stream.

Path parameters
block_idstringRequired

Hex-encoded parent block ID (64 characters)

Pattern: ^[0-9a-f]{64}$
seqinteger · max: 65535Required

Starting sequence number (0-65535)

Responses
chevron-right
200

Stream of unconfirmed microblocks

application/octet-stream
string · binaryOptional
get
/v2/microblocks/unconfirmed/{block_id}/{seq}

Submit a microblock (Epoch 2.x)

post
/v2/microblocks

Submit a microblock to the node for validation and relay. The body must be the SIP-003 binary serialization of a Microblock and sent with Content-Type: application/octet-stream.

Body
string · binary · min: 1Optional
Responses
chevron-right
200

Index-block hash of the accepted microblock

application/json
stringOptional

32-byte block-header hash (hex)

Pattern: ^[0-9a-f]{64}$
post
/v2/microblocks

Get recent 2.x block headers

get
/v2/headers/{quantity}

Deprecated: This endpoint is deprecated since Nakamoto.** Stream (as a JSON array) up to quantity most recent anchored Stacks block headers. The result is ordered from the current tip backwards.

Path parameters
quantityinteger · min: 1 · max: 256Required

Number of headers to return (max 256)

Query parameters
tipstring · max: 64Optional

Stacks chain tip to query from. Options:

  • (empty/omitted): Use latest anchored tip (canonical confirmed state)
  • latest: Use latest known tip including unconfirmed microblocks
  • {block_id}: Use specific block ID (64 hex characters)
Example: latestPattern: ^(latest|[0-9a-f]{64})?$
Responses
chevron-right
200

Array of block headers

application/json

JSON array returned by /v2/headers/{quantity}. Each entry is an ExtendedStacksHeader.

consensus_hashstringRequired

20-byte burn-chain consensus hash (hex, no 0x prefix)

Pattern: ^[0-9a-f]{40}$
headerstringRequired

Hex-encoded SIP-003 serialization of the Stacks block header

Pattern: ^[0-9a-f]+$
parent_block_idstringRequired

32-byte index-block ID of the parent Stacks block (hex)

Pattern: ^[0-9a-f]{64}$
get
/v2/headers/{quantity}

Get Stacks 2.x block by ID

get
/v2/blocks/{block_id}

Get a specific Stacks 2.x era block by its block ID. This endpoint streams the block data from the filesystem storage where traditional Stacks blocks are stored as individual files.

Compatibility: Works with all Stacks 2.x blocks. For Nakamoto blocks (Stacks 3.x+), use /v3/blocks/{block_id}.

Path parameters
block_idstringRequired

Hex-encoded block ID (64 characters)

Pattern: ^[0-9a-f]{64}$
Responses
chevron-right
200

The block data

application/octet-stream
string · binaryOptional
get
/v2/blocks/{block_id}

Get tenure fork information

get
/v3/tenures/fork_info/{start}/{stop}

Get information about tenure forking between two consensus hashes. This is used to identify conflicting tenures in the Nakamoto consensus.

Path parameters
startstringRequired

Starting consensus hash (40 hexadecimal characters, without 0x prefix)

Pattern: ^[0-9a-f]{40}$
stopstringRequired

Stopping consensus hash (40 hexadecimal characters, without 0x prefix)

Pattern: ^[0-9a-f]{40}$
Responses
chevron-right
200

Ordered list of tenure fork events from stop back to (and including) start

application/json

Information about a tenure used for fork-detection.

burn_block_hashstringRequired

0x-prefixed 32-byte Bitcoin block hash that triggered the tenure event

Pattern: ^0x[0-9a-fA-F]{64}$
burn_block_heightinteger · uint64Required
sortition_idstringRequired

0x-prefixed 32-byte sortition ID (unique across PoX and Bitcoin forks)

Pattern: ^0x[0-9a-fA-F]{64}$
parent_sortition_idstringRequired

0x-prefixed sortition ID of the parent burn block

Pattern: ^0x[0-9a-fA-F]{64}$
consensus_hashstringRequired

0x-prefixed 20-byte consensus hash identifying the tenure

Pattern: ^0x[0-9a-fA-F]{40}$
was_sortitionbooleanRequired

Whether a winning sortition occurred at this burn block

first_block_minedstring · nullableOptional

0x-prefixed index-block ID of the first Stacks block in the tenure (if any)

Pattern: ^0x[0-9a-fA-F]{64}$
nakamoto_blocksstring · nullableOptional

0x-prefixed SIP-003 binary encoding of all Nakamoto blocks mined in this tenure

get
/v3/tenures/fork_info/{start}/{stop}

Get tenure tip

get
/v3/tenures/tip/{consensus_hash}

Get the tip block of a tenure identified by consensus hash.

Path parameters
consensus_hashstringRequired

Consensus hash (40 characters)

Pattern: ^[0-9a-f]{40}$
Responses
chevron-right
200

Tenure tip block information

application/json

JSON encoding of StacksBlockHeaderTypes returned by /v3/tenures/tip. Exactly one variant property will be present: either Epoch2 or Nakamoto.

or
get
/v3/tenures/tip/{consensus_hash}

Get tenure tip with metadata

get
/v3/tenures/tip_metadata/{consensus_hash}

Get the tip block and associated metadata of a tenure identified by consensus hash.

Path parameters
consensus_hashstringRequired

Consensus hash (40 characters)

Pattern: ^[0-9a-f]{40}$
Responses
chevron-right
200

Tenure tip block information

application/json

JSON encoding of BlockHeaderWithMetadata returned by /v3/tenures/tip_metadata. Exactly one variant property will be present: either Epoch2 or Nakamoto.

burn_viewstringOptional

Hex-encoded bitcoin block hash

anchored_headerone ofRequired
or
get
/v3/tenures/tip_metadata/{consensus_hash}

Upload a Nakamoto block

post
/v3/blocks/upload

Upload a Nakamoto block to the node for processing.

  • Body - must be the binary (SIP-003) serialization of a NakamotoBlock.

  • Authentication - only required when the query parameter broadcast=1 is supplied. In that case the caller must include an Authorization header.

Authorizations
authorizationstringOptional

Plain-text secret value that must exactly equal the node's configured password, which is set as connection_options.auth_token in the node's configuration file.

Query parameters
broadcaststring · enumOptional

If set to "1" the node will broadcast the uploaded block to peers. When present the request must include a valid Authorization header.

Possible values:
Body
string · binary · min: 1Optional

Binary SIP-003 encoding of a NakamotoBlock

Responses
chevron-right
200

Block upload result.

application/json
stacks_block_idstringOptional

The ID of the uploaded block

acceptedbooleanOptional

Whether the block was accepted

post
/v3/blocks/upload

Replay mining of a block and returns its content

get
/v3/blocks/replay/{block_id}

Replay the mining of a block (no data is written in the MARF) and returns its content.

Authorizations
authorizationstringRequired

Plain-text secret value that must exactly equal the node's configured password, which is set as connection_options.auth_token in the node's configuration file.

Path parameters
block_idstringRequired

The block ID hash

Pattern: ^[0-9a-f]{64}$
Responses
chevron-right
200

Content of the replayed block

application/json
block_hashstringOptional

Hash of the block

Pattern: ^[0-9a-f]{64}$
block_idstringOptional

Block ID (index block hash)

Pattern: ^[0-9a-f]{64}$
block_heightinteger · uint64Optional

Height of the Stacks block

consensus_hashstringOptional

Consensus hash of the tenure

Pattern: ^[0-9a-f]{40}$
feesintegerOptional

total fees for the block

miner_signaturestringOptional

Uncompressed signature of the miner

Pattern: ^[0-9a-f]{130}$
parent_block_idstringOptional

Parent Block ID (index block hash)

Pattern: ^[0-9a-f]{64}$
signer_signaturestring[]Optional

Uncompressed signature of the signer

state_index_rootstringOptional

block state index root computed from the MARF (got from the original block)

Pattern: ^[0-9a-f]{64}$
timestampintegerOptional
tx_merkle_rootstringOptional

merkle_root of the included transactions

valid_merkle_rootbooleanOptional

does the merkle_root matches the chain block and the simulated one?

get
/v3/blocks/replay/{block_id}

Simulate mining of a block with the specified transactions and returns its content

get
/v3/blocks/simulate/{block_id}

Simulate the mining of a block (no data is written in the MARF) with specified transactions and returns its content.

Authorizations
authorizationstringRequired

Plain-text secret value that must exactly equal the node's configured password, which is set as connection_options.auth_token in the node's configuration file.

Path parameters
block_idstringRequired

The block ID hash

Pattern: ^[0-9a-f]{64}$
Body
transactions_hexstring[]Optional

SIP-003-encoded Transaction in hex format

Responses
chevron-right
200

Content of the simulated block

application/json
block_hashstringOptional

Hash of the block

Pattern: ^[0-9a-f]{64}$
block_idstringOptional

Block ID (index block hash)

Pattern: ^[0-9a-f]{64}$
block_heightinteger · uint64Optional

Height of the Stacks block

consensus_hashstringOptional

Consensus hash of the tenure

Pattern: ^[0-9a-f]{40}$
feesintegerOptional

total fees for the block

miner_signaturestringOptional

Uncompressed signature of the miner

Pattern: ^[0-9a-f]{130}$
parent_block_idstringOptional

Parent Block ID (index block hash)

Pattern: ^[0-9a-f]{64}$
signer_signaturestring[]Optional

Uncompressed signature of the signer

state_index_rootstringOptional

block state index root computed from the MARF (got from the original block)

Pattern: ^[0-9a-f]{64}$
timestampintegerOptional
tx_merkle_rootstringOptional

merkle_root of the included transactions

valid_merkle_rootbooleanOptional

does the merkle_root matches the chain block and the simulated one?

get
/v3/blocks/simulate/{block_id}

Last updated

Was this helpful?